﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Data;
using System.Data.SqlClient;


/// <summary>
/// Summary description for DAL
/// </summary>
public class DAL
{
    //פעולה היוצרת עצם ליצירת קשר עם מסד הנתונים ומחזירה אותו
	public static SqlConnection GetConnection()
	{
        //יודע לחבר דטה בייס מסוג אסקיואל - הגדרת החיבור
        SqlConnection con = new SqlConnection();
        //יוצר את מחרוזת הקשר ושם אותה במבנה. שטרודל הופך את כל התווים לרגילים
        //con.ConnectionString = @"Data Source=(LocalDB)\v11.0;AttachDbFilename=|DataDirectory|\database.mdf;Integrated Security=True";
        con.ConnectionString = @"Data Source=(LocalDB)\MSSQLLocalDB;AttachDbFilename=|DataDirectory|\Database.mdf;Integrated Security=True";
        return con;
	}

    //פעולה המקבלת עצם היוצר קשר עם מסד הנתונים ומחרוזת שאילתה ומחזירה מבנה פקודה
    public static SqlCommand GetCommand(SqlConnection con, string sqlStr)
    {
        SqlCommand cmd = new SqlCommand();//עצם נותן הוראות
        cmd.Connection = con;
        cmd.CommandType = CommandType.Text;
        cmd.CommandText = sqlStr;
        return cmd;
    }
    
    //פעולה המקבלת מחרוזת של שאילתה, ולצורך גישה דיסקונקטד למסד הנתונים
    //מחזירה מבנה דטה טייבל הכולל את תוצאות השאילתה בצורה של טבלה
    public static DataTable GetTable(string sql)
    {
        SqlConnection con = DAL.GetConnection();

        SqlCommand cmd = DAL.GetCommand(con, sql);

        DataTable dt = new DataTable();
        SqlDataAdapter adp = new SqlDataAdapter();
        adp.SelectCommand = cmd;

        adp.Fill(dt);
        return dt;
    }

    // הפעולה מקבלת שם קובץ ומשפט לביצוע ומבצעת את הפעולה על המסד
    //מבצעת פעולות הוספה / עדכון / מחיקה בהתאם למשפט שקיבלה
    // הפעולה מחזירה את מספר השורות שהושפעו במסד הנתונים
    // או  -1 אם קימת בעית תקשורת עם מסד הנתונים
    public static int ExecuteNonQuery(string sql)
    {
        SqlConnection con = DAL.GetConnection();//יצירת קשר לדטה בייס
        con.Open();//לפתוח את הקשר לדטה בייס
        if (con.State != ConnectionState.Open)//אם הקובץ לא פתוח 
            return(-1);// נחזיר שיש בעיה
        SqlCommand cmd = DAL.GetCommand(con, sql);//הכנת אובייקט בשאילתה
        int rows = cmd.ExecuteNonQuery();//ביצוע השאילת ועדכון משתנה המכיל את מספר השורות שעברו שינוי
        con.Close();
        return(rows);
    }
}