﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Data;
using System.Data.SqlClient;

/// <summary>
/// Summary description for UserDB
/// </summary>
public class UserDB
{
    //הפעולה מקבלת שם משתמש ומחזירה איידי או מינוס אחד אם לא נמצא או הייתה שגיאה
	public static int GetUserId(string uname)
	{
        int id=-1;
        SqlConnection con = DAL.GetConnection();
		con.Open();//פתיחת הקשר

        if (con.State == ConnectionState.Open)
        {
            string str = "SELECT Id FROM UsersTbl WHERE Uname=N'" + uname + "'";
            SqlCommand cmd = DAL.GetCommand(con, str);

            object obj=cmd.ExecuteScalar();//סקלר מחזיר רק אחד
        if(obj !=null)
            id=(int)obj;
        }
        return id;
	}

   //הפעולה מציגה את רשימת הערים- להרשמה
    public static string GetCityOptions()
    {
        DataTable dt = DAL.GetTable("Select * from CitiesTbl");

        string str="";
        foreach(DataRow row in dt.Rows)
        {
            str+="<option value='"+row["Id"]+"'>"+row["City"]+"</option>";
        }

        return str;
    }

    //הפעולה מקבלת עיר ומסמנת אותה כנבחרת ברשימה - לעידכון
    public static string GetCityOptions(int city)
    {

        DataTable dt = DAL.GetTable("SELECT * from CitiesTbl");

        string str = "", s;


        foreach (DataRow row in dt.Rows)
        {
            s = "";
            if ((int)row["id"] == city)
                s = " selected ";
            str = str + "<option value='" + row["Id"] + "'" + s + ">" + row["City"] + "</option>";
        }
        return str;
    }

    // הפעולה מקבלת מחרוזת עם אפשרות נוספת לרשימה נגללת- לחיפוש
    public static string GetCityOptions(string str)
    {
        
        DataTable dt = DAL.GetTable("Select * from CitiesTbl");

        foreach (DataRow row in dt.Rows)
        {
            str += "<option value='" + row["Id"] + "'>" + row["City"] + "</option>";
        }

        return str;
    }

    //הפעולה מקבלת קוד של עיר ומחזירה את שם העיר- להצגת נתונים
    public static string ShowCity(int cId)
    {
        DataTable dt = DAL.GetTable("SELECT * from CitiesTbl WHERE Id=" + cId);
        return (string)dt.Rows[0]["City"];
    }


    //הפעולה מחזירה את אפשרויות הקידומות- להרשמה
    public static string GetAreaCodesOptions()
    {

        DataTable dt = DAL.GetTable("SELECT * from AreaCodesTbl");

        string str = "";


        foreach (DataRow row in dt.Rows)
        {
            str = str + "<option value='" + row["Id"] + "'>" + row["AreaCode"] + "</option>";
        }
        return str;
    }

    //הפעולה מקבלת קידומת ומסמנת אותה כנבחרת ברשימה - לעדכון
    public static string GetAreaCodesOptions(int aCode)
    {

        DataTable dt = DAL.GetTable("SELECT * from AreaCodesTbl");

        string str = "", s;


        foreach (DataRow row in dt.Rows)
        {
            s = "";
            if ((int)row["Id"] == aCode)
                s = " selected ";
            str = str + "<option value='" + row["Id"] + "'" + s + ">" + row["AreaCode"] + "</option>";
        }
        return str;
    }

    //הפעולה מקבלת איידי של קידומת ומחזירה את הקידומת- להצגת נתונים
    public static string ShowAreaCode(int aId)
    {
        DataTable dt = DAL.GetTable("SELECT * from AreaCodesTbl WHERE Id=" + aId);
        return (string)dt.Rows[0]["AreaCode"];
    }

    public static string ShowGender(bool gCode)
    {
        if (gCode)
            return "נקבה";
        return "זכר";
    }

    public static string ShowIsAdmin(bool isACode)
    {
        if (isACode)
            return "מנהל";
        return "משתמש";
    }


    //הפעולה מציגה את רשימת ענפי הספורט- להוספת סוס
    public static string GetSportsOptions()
    {
        DataTable dt = DAL.GetTable("Select * from SportsTbl");
        string str = "";
        foreach (DataRow row in dt.Rows)
        {
            str += "<option value='" + row["Id"] + "'>" + row["Sport"] + "</option>";
        }
        return str;
    }

    //הפעולה מקבלת תוספת לרשימת ענפי הספורט
    //הפעולה מציגה את רשימת ענפי הספורט- לחיפוש סוס, בתוספת מה שהתקבל
    public static string GetSportsOptions(string prefix)
    {
        return prefix + GetSportsOptions();
    }

    //הפעולה מקבלת ענף ספורט ומסמנת אותו כנבחר ברשימה - לעידכון
    public static string GetSportsOptions(int sport)
    {

        DataTable dt = DAL.GetTable("SELECT * from SportsTbl");

        string str = "", s;


        foreach (DataRow row in dt.Rows)
        {
            s = "";
            if ((int)row["id"] == sport)
                s = " selected ";
            str = str + "<option value='" + row["Id"] + "'" + s + ">" + row["Sport"] + "</option>";
        }
        return str;
    }
    //הפעולה מקבלת קוד של תחום ספורט ומחזירה את שם פעילות הספורט
    public static string ShowSport(int sId)
    {
        DataTable dt = DAL.GetTable("SELECT * from SportsTbl WHERE Id=" + sId);
        return (string)dt.Rows[0]["Sport"];
    }


    //הפעולה מחזירה את אפשרויות גזע הסוס
    public static string GetBreedCodesOptions()
    {

        DataTable dt = DAL.GetTable("SELECT Breed from HorsesTbl GROUP BY Breed");

        string str = "";


        foreach (DataRow row in dt.Rows)
        {
            str = str + "<option value='" + row["Breed"] + "'>" + row["Breed"] + "</option>";
        }
        return str;
    }

    // הפעולה מקבלת קידומת תוספת אפשרויות לגזעי סוסים    
    // הפעולה מחזירה את אפשרויות גזע הסוס לחיפוש ממסד הנתונים בתוספת האפשרויות שהועברו כפרמטר
    public static string GetBreedCodesOptions(string prefix)
    {
        return prefix + GetBreedCodesOptions();
    }

    // חישוב גיל בשנים
    // הפעולה מקבלת תאריך ומחזירה את הגיל בשנים, בדיוק 2 ספרות אחרי הנקודה
    public static double ShowAgeInYears(DateTime d)
    {
        DateTime today = DateTime.Today;  // התאריך של היום
        double ageInDays = (today - d).TotalDays; // חישוב מספר הימים בין התאריכים
        return Math.Round(ageInDays / 365.2425, 2);  // חלוקה במספר הימים בשנה לקבלת מספר השנים ועיגולו
    }

    // חישוב גיל ממוצע של שדה יום הולדת במסד הנתונים
    // הפעולה מקבלת שם מסד נתונים, שם שדה המכיל תאריך 
    // הפעולה מחזירה את הגיל הממוצע של כל הרשומות במסד הנתונים
    public static double ShowAgeInYears(string dataBase, string fieldName)
    {
        return ShowAgeInYears(dataBase, fieldName, "1=1");
    }

    // חישוב גיל ממוצע של שדה יום הולדת במסד הנתונים
    // הפעולה מקבלת שם מסד נתונים, שם שדה המכיל תאריך ומחרוזת תנאי סינון
    // הפעולה מחזירה את הגיל הממוצע של כך הרשומות במסד הנתונים העונות לתנאי הסינון
    public static double ShowAgeInYears(string dataBase, string fieldName, string where)
    {
        /* שאילתא הרצה על כל טבלת הסוסים ומחשבת ממוצע של גיל הסוסים */
        /* GETDATE() - תאריך נוכחי */
        /* DATEDIFF(datepart,startdate,enddate) -  הפרש תאריכים ביחידות של ביחידות של datepart*/
        /* AVG(column_name) - חישוב ממוצע של העמודה המחושבת */
        DataTable dt = DAL.GetTable("SELECT AVG(DATEDIFF(year," + fieldName + ",GETDATE())) as 'AvgAge' FROM " + dataBase + " WHERE " + where);

        if (dt.Rows[0]["AvgAge"].ToString() != "")
            return (int)dt.Rows[0]["AvgAge"];
        else
            return 0;
    }

}