﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data.SqlClient;
using System.Data;

public partial class HorseList : System.Web.UI.Page
{
    protected string str = "<table><tr>";
    protected string sums;
    protected void Page_Load(object sender, EventArgs e)
    {
        // מספר העמודות בטבלה
        int maxColumn = 3, i = 0;
        string where;
        
        if (Session["id"] == null)
            Response.Redirect("Default.aspx");

        //בניית מחרוזת הסינון לרשומות שיוצגו
        if (Request.Form.Count > 0) // אם מספר השדות שהתקבלו מהמסך גדול מאפס
            where = SearchHorseQString();
        else
            where = "1=1";

        DataTable dt = DAL.GetTable("SELECT * FROM HorsesTbl WHERE " + where);

        // הצגת דו"ח סטטיסטי 0 כמב רשומות נמצאו ומה הגיל הממוצע
        sums = "סה''כ רשומות שאוחזרו:  " + dt.Rows.Count + ", גיל סוס ממוצע: " + UserDB.ShowAgeInYears("HorsesTbl", "BirthDate", where) + " שנים.";
        
        // בניית טבלת הסוסים. כל סוס בתוך תא בטבלה החיצונית
        // שדות הסוס מוצגים כטבלה פנימית, כאשר הטבלה הפנימית היא תא בטבלה החיצוני
        // כל maxColumn סוסים, נרד שורה בטבלה החיצונת
        foreach (DataRow row in dt.Rows)
        {
            str += "<td><table><tr>";
            str += "<td> <a href=\"HorseDetails.aspx?action=display&hId=" + row["Id"] + "\"><img class='horses_medium' src=\"" + row["Picture"] + "\" alt='תמונת סוס'></a></td></tr> ";
            str += "<tr><td> <a class='horselink' href=\"HorseDetails.aspx?action=display&hId=" + row["Id"] + "\"> <strong>" + row["Name"] + "</strong></a></td></tr>";
            str += "<tr><td>גזע " + row["Breed"] + " ממין " + UserDB.ShowGender((bool)row["Gender"]);
            str += " בגיל " + UserDB.ShowAgeInYears((DateTime)row["BirthDate"]) + " שנים</td></tr>";
            str += "</table>"; // סגירת טבלה פנימית להצגת מידע תמציתי על סוס
            if ((++i)%maxColumn == 0)  // אם הגיעו לכמות העמודות המקסימאלית
                str += "</tr><tr>"; // תיפתח שורה חדשה
        }
        // סיימנו לעבור על כל הסוסים - נסגור את הטבלה החיצונית
        str += "</tr></table>";
    }

    // הפעולה בודקת את שדות החיפוש שהתקבלו מהמסך ובונה את מחרוזת החיפוש למסד הנתונים 
    protected string SearchHorseQString()
    {
        string where = string.Format(" Name LIKE N'%{0}%' ", Request.Form["Name"]);
        if (Request.Form["Breed"] != "0")
            where += string.Format(" AND Breed=N'{0}'", Request.Form["Breed"]);
        if (Request.Form["gender"] != null)
            where += string.Format(" AND Gender={0}", int.Parse(Request.Form["Gender"]));
        if (int.Parse(Request.Form["city"]) != 0)
            where += string.Format(" AND City={0}", Request.Form["city"]);
        if (int.Parse(Request.Form["Sport"]) != 0)
            where += string.Format(" AND Sport={0}", Request.Form["Sport"]);
        if (Request.Form["bdatefrom"] != "")
            where += string.Format(" AND BirthDate >='{0}'", DateTime.Parse(Request.Form["bdatefrom"]));
        if (Request.Form["bdateto"] != "")
            where += string.Format(" AND BirthDate <='{0}'", DateTime.Parse(Request.Form["bdateto"]));
        return where;
    }

}