﻿//בדיקות תקינות בצד לקוח

// בדיקת שדה במבנה שם - מכיל רק אותיות ורווחים באורך מוגדר
// הפעולה מקבלת מחרוזת לבדיקה
// אם המחרוזת תקינה מחזירה אמת, אחרת מחזירה שקר ואת הודעת השגיאה
function checkName(name, err)
{
    err.innerHTML = "";
    var isOkay = true;
    if (name.length < 2 || name.length > 30)
    {
        err.innerHTML += "אורך השם אינו תקין. שם חייב להיות באורך של 2-30 תווים. ";
        isOkay = false;
    }
    var ltr = numOfLetters(name);
    var spaces=0;
    for(var i=0; i<name.length; i++)
        if(name.charAt(i)==' ')
            spaces++;
    if (ltr+spaces != name.length)
    {
        err.innerHTML += "שם יכול להכיל אותיות ורווחים בלבד. ";
        isOkay = false;
    }
    return isOkay;
}

// הפעולה מחזירה אמת אם המחרוזת מכילה רק את רשימת התווים המוגדרים ע"י התבנית pat
function checkStr(str)
{
    /* הגדרת רשימת תווים חוקיים  */
    /* אותיות, מספרים, נקודותיים, נקודה, פסיק, סימן קריאה, קו תחתון, קו אלכסוני, רווח, מקף או ירידת שורה */
    var pat = /^[a-zA-Zא-ת0-9|:.,!_\/\ \-\n]*$/;

    return pat.test(str);
}

// בדיקת שדה במבנה מחרוזת - מכילה רק תווים שהוגדרות כחוקיים
// הפעולה מקבלת מחרוזת לבדיקה
// אם המחרוזת תקינה מחזירה אמת, אחרת מחזירה שקר ואת הודעת השגיאה
function checkStrErr(str, err)
{
    err.innerHTML = "";
    var isOkay = checkStr(str);
    if (!isOkay)
        err.innerHTML += "יש להזין מחרוזת חוקית הכוללת תווים של אותיות, מספרים, רווחים וסימני פיסוק.";
    
    return isOkay;
}

// בדיקת שדה במבנה שם משתמש - מכיל רק אותיות ומספרים באורך מוגדר
// הפעולה מקבלת מחרוזת לבדיקה
// אם המחרוזת תקינה מחזירה אמת, אחרת מחזירה שקר ואת הודעת השגיאה
function checkUname(uname, err)
{  
    err.innerHTML = "";
    var isOkay = true;
    if (uname.length < 2 || uname.length > 30)
    {
        err.innerHTML += "אורך שם המשתמש אינו תקין. שם משתמש חייב להיות באורך של 2-30 תווים. ";
        isOkay = false;
    }
    var dig = numOfDigits(uname);
    var ltr = numOfLetters(uname);
    if (ltr + dig != uname.length)
    {
        err.innerHTML += "שם משתמש יכול להכיל אותיות ומספרים בלבד.";
        isOkay = false;
    }
    return isOkay;
}

// בדיקת שדה במבנה סיסמא - מכיל רק אותיות ומספרים באורך מוגדר
// עם לפחות 3 אותיות ולפחות 3 מספרים
// הפעולה מקבלת מחרוזת לבדיקה
// אם המחרוזת תקינה מחזירה אמת, אחרת מחזירה שקר ואת הודעת השגיאה
function checkPassword(pass, err)
{
    err.innerHTML = "";
    var isOkay = true;
    if (pass.length < 6 || pass.length > 30)
    {
        err.innerHTML = "אורך הסיסמה אינו תקין. סיסמה חייבת להיות באורך של 6-30 תווים. ";
        isOkay = false;
    }
    else
    {
        var dig = numOfDigits(pass);
        if (dig < 3)
        {
            err.innerHTML += "סיסמה חייבת להכיל לפחות 3 ספרות. ";
            isOkay = false;
        }
        var ltr = numOfLetters(pass);
        if (ltr < 3)
        {
            err.innerHTML += "סיסמה חייבת להכיל לפחות 3 אותיות. ";
            isOkay = false;
        } 
        if (ltr + dig != pass.length)
        {
            err.innerHTML += "סיסמה יכולה להכיל אותיות ומספרים בלבד. ";
            isOkay = false;
        }
    }
    return isOkay;
}

// בדיקת שדה במבנה דוא"ל - מכיל רק @ אחד לא בקצוות ובין 1-5 נקודות אחריו שאינן רצופות
// הפעולה מקבלת מחרוזת לבדיקה
// אם המחרוזת תקינה מחזירה אמת, אחרת מחזירה שקר ואת הודעת השגיאה
function checkEmail(email, err)
{
    err.innerHTML = "";
    var isOkay = true;
    var atPos = email.split('@');//מחלק למערך של מחרוזות
    if (atPos.length != 2)
    {
        err.innerHTML += "אימייל חייב להכיל @ אחד. ";
        return false;
    } 
    if (atPos[0].length == 0)
    {
        err.innerHTML += "@ אינו יכול לפתוח כתובת מייל. ";
        isOkay = false;
    } 
    if (atPos[1].length == 0)
    {
        err.innerHTML += "@ אינו יכול לסיים כתובת מייל. ";
        isOkay = false;
    }
    else {
        var dot = atPos[1].split('.');
        if (dot.length <= 1 || dot.length > 5) {
            err.innerHTML += "לאחר @ בכתובת מייל צריכות להופיע 1-5 נקודות. ";
            isOkay = false;
        }
        for (var i = 0; i < dot.length; i++) {
            if (dot[i].length == 0) {
                err.innerHTML += "אסור שהנקודות בכתובת מייל יהיו רצופות, יפתחו או יסגרו את הכתובת. ";
                isOkay = false;
            }
        }
    }
    return isOkay;
}

// בדיקת שדה במבנה מספר טלפון - מכיל רק 7 ספרות
// הפעולה מקבלת מחרוזת לבדיקה
// אם המחרוזת תקינה מחזירה אמת, אחרת מחזירה שקר ואת הודעת השגיאה
function checkPhoneNumber(phone, err)
{
    err.innerHTML = "";
    var dig = numOfDigits(phone);
    if(dig!=7||dig!=phone.length)
    {
        err.innerHTML = "מספר טלפון יכול להכיל ספרות בלבד וחייב להיות באורך של 7 ספרות. ";
        return false;
    }
    return true;
}

// בדיקת שדה במבנה שם - פורמט DD/MM/YYYY, כאשר הערכים של DD, MM, YYYY נמצאים בתחום תקין
// הפעולה מקבלת מחרוזת לבדיקה
// אם המחרוזת תקינה מחזירה אמת, אחרת מחזירה שקר ואת הודעת השגיאה
function checkDate(date, err)
{
    err.innerHTML = "";
    var isOkay = true;
    var slash = date.split('/');
    if (slash.length!=3)
    {
        err.innerHTML += "תאריך חייב להיות במבנה של dd/mm/yyyy.";
        isOkay= false;
    }
    else
    {
        if (!(Number(slash[0]) >= 1 && Number(slash[0]) <= 31))
        {
            err.innerHTML += "יום בתאריך חייב להיות בין 01 ל-31. ";
            isOkay = false;
        }
        if (!(Number(slash[1]) >= 1 && Number(slash[1]) <= 12))
        {
            err.innerHTML += "חודש בתאריך חייב להיות בין 01 ל-12. ";
            isOkay = false;
        }
        var today = new Date();
        if (!(Number(slash[2]) >= 1900 && Number(slash[2]) <= today.getFullYear()))
        {
            err.innerHTML += "שנה בתאריך חייבת להיות בין 1900 ל-" + today.getFullYear() + ". ";
            isOkay = false;
        }
    }
    return isOkay;
}


// הפעולה מחזירה את מספר האותיות במחרוזת
function numOfLetters(str) {
    var counter = 0;
    for (var i = 0; i < str.length; i++)
        if (str.charAt(i) >= 'a' && str.charAt(i) <= 'z' ||
        str.charAt(i) >= 'A' && str.charAt(i) <= 'Z' ||
        str.charAt(i) >= 'א' && str.charAt(i) <= 'ת')
            counter++;
    return counter;
}

// הפעולה מחזירה את מספר האותיות במחרוזת
function numOfDigits(str)
{
    var counter = 0;
    for (var i = 0; i < str.length; i++)
        if (str.charAt(i) >= '0' && str.charAt(i) <= '9')
            counter++;

    return counter;
}